<?php
/*
Plugin Name: ads-WpSiteCount
Plugin URI: www.ad-soft.ch/wpsitecount
Author: ad-software
Author URI: http://ad-soft.ch
Description: Count the page hit from each ip and display a counter into widget or page.
Version: 2.18
License: GNU General Public License v2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
Tags: Wp Site Count, ad-software, Display Site Counter
Text Domain: ads_wpsitecount
Domain path: /lang
Date: 2016/02/09 // 2017/04/21
PHP: 7.4.6

Copyright 2014  ad-software andré
contact me at www.ad-soft.ch/support

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
defined('ABSPATH') OR exit;

//=================================
//Constants
//=================================
if (!defined('ADS_HOME_URL'))	define('ADS_HOME_URL','http://www.ad-soft.ch/wpplugins');
if (!defined('ADS_PAGEFILE'))	define('ADS_PAGEFILE', 'adsPage'); 
if (!defined('ADS_PLUGIN_DIR'))	define('ADS_PLUGIN_DIR', plugin_dir_path(__FILE__)); 
if (!defined('ADS_COUNTER_DIR'))	define('ADS_COUNTER_DIR', ADS_PLUGIN_DIR.'counters/'); 
if (!defined('ADS_BACKGROUND_DIR'))	define('ADS_BACKGROUND_DIR', ADS_PLUGIN_DIR.'background/'); 
if (!defined('ADS_BACKGROUND_URL'))	define('ADS_BACKGROUND_URL', plugins_url('background/', __FILE__ )); 
if (!defined('ADS_STYLE_DIR'))	define('ADS_STYLE_DIR', ADS_PLUGIN_DIR.'css/'); 
if (!defined('ADS_STYLE_URL'))	define('ADS_STYLE_URL', plugins_url( '/css/' , __FILE__ )); 
if (!defined('ADS_STYLE_NAMECSS'))	define('ADS_STYLE_NAMECSS', 'ads_styles.css'); 
if (!defined('ADS_SCRIPT_URL'))	define('ADS_SCRIPT_URL', plugins_url( '/js/' , __FILE__ )); 
if (!defined('ADS_SCRIPT_NAMEJS'))	define('ADS_SCRIPT_NAMEJS', 'adswsc_script.js');
if (!defined('ADS_LANG_DIRNAME'))	define('ADS_LANG_DIRNAME', '/lang/');
if (!defined('ADS_TEXT_DOMAIN'))	define('ADS_TEXT_DOMAIN','ads_wpsitecount'); 
if (!defined('ADS_OPTIONS_SHORTCODE'))	define('ADS_OPTIONS_SHORTCODE', 'adswsc_Shortcode');
if (!defined('ADS_OPTIONS_GENERAL'))	define('ADS_OPTIONS_GENERAL', 'adswsc_General');
if (!defined('ADS_OPTIONS_RANDOM'))	define('ADS_OPTIONS_RANDOM', 'adswsc_Random');
if (!defined('ADS_PLUGIN_NAME'))	define('ADS_PLUGIN_NAME', 'ADS-WpSiteCount');
if (!defined('ADS_PLUGIN_NAMESC'))	define('ADS_PLUGIN_NAMESC', 'ads-wpsitecount');
if (!defined('ADS_IMAGE_URL'))	define('ADS_IMAGE_URL', plugins_url( '/images/' , __FILE__ ));
$ul = wp_upload_dir();
if (!defined('ADS_UPLOAD_DIR'))	define('ADS_UPLOAD_DIR', $ul['basedir']);
if (!defined('ADS_UPLOAD_TPLNAME'))	define('ADS_UPLOAD_TPLNAME', '/adswsc-templates/');
if (!defined('ADS_UPLOAD_TPLDIR'))	define('ADS_UPLOAD_TPLDIR', ADS_UPLOAD_DIR.ADS_UPLOAD_TPLNAME);

//=================================
//Load Widget
//=================================
if (!class_exists('adswsc_clsWidget') ) require_once(plugin_dir_path(__FILE__).'includes/ads_widgets.php'); 
if (!class_exists('adswsc_clsShortCode') ) require_once(plugin_dir_path(__FILE__).'includes/ads_shortcode.php'); 

//=================================
//Load Settings
//=================================
if( is_admin() ) {
	require_once(plugin_dir_path(__FILE__).'includes/ads_options.php');
	require_once(plugin_dir_path(__FILE__).'includes/ads_dashwidget.php');
	require_once(plugin_dir_path(__FILE__).'includes/ads_usagwidget.php');
}	

//=================================
function adswsc_isAdmin() {
	$a  = in_array('administrator',  wp_get_current_user()->roles);
	return $a;
}

//=================================
function adswsc_GetOptions($settings, $default = false) {
	$options = get_option($settings);
	switch($settings) {
		case ADS_OPTIONS_GENERAL:
			if (!is_array( $options ) || $default==true) {
				$options = array(
					'Counter' => 0,
					'Lastreset' => current_time('timestamp'),
					'CycleTime' => 1800, //30 min
					'DeleteTime' => (60*24*3600), // 2 month
					'CleanupTime' => (30*24*3600), // 1 month
					'Cleanup' => (current_time('timestamp') + (30*24*3600)), // +1 month
					'Bots' => '',
					'PageOn' => 'on',
					'PageTime' => (1*60),
					'TinyTcOn' => '',
					'UseAjax' => '',
					'New' => 1
				);
			}
			$options['UseAjax'] = isset($options['UseAjax']) ? $options['UseAjax'] : '';
			break;
		case ADS_OPTIONS_SHORTCODE:
			if (!is_array( $options ) || $default==true) {
				$options = array(
					'title' => '',
					'before' => '',
					'after' =>  '',
					'width' => 165,
					'height' => '',
					'whunit' => 'px',
					'image' => 'flippingnumbers.jpg',
					'align' => 'none',
					'length' => 5,
					'fill' => '',
					'text' => '',
					'page' => '',
					'admin' => '',
					'block' => '',
					'imgmaxw' => 250,
					'randimg' => '',
					'bosize' => 3,
					'botype' => 'inset',
					'bocolor' => 'white',
					'boradius' => 3, 
					'count' => 0,
					'add' => 0,
					'nocount' => '',
					'reset' => '',
					'save' => '',
				);
			}	
			break;
		case ADS_OPTIONS_RANDOM:
			if (!is_array( $options ) || $default==true) {
				$options = array(
					'image' => 'flippingnumbers.jpg',
					'time' => 0
				);
			}	
			break;
		default: 
			return null;
	}
	return $options;
}

//=================================
function adswsc_GetRandomImage($randimg, $image) {
	$rand = adswsc_GetOptions( ADS_OPTIONS_RANDOM );
	$newimg = false;
	switch (intval($randimg)) {
		case 1: // hour
			if ($rand['time'] != date('h')) {
				$newimg = true;
				$rand['time'] = date('h');
			}
			break;
		case 2: //day
			if ($rand['time'] != date('d')) {
				$newimg = true;
				$rand['time'] = date('d');
			}
			break;
		case 3:	// week
			if ($rand['time'] != date('w')) {
				$newimg = true;
				$rand['time'] = date('w');
			}
			break;
		case 4:	// month
			if ($rand['time'] != date('m')) {
				$newimg = true;
				$rand['time'] = date('m');
			}
			break;
		case 5: // minutes
			if ($rand['time'] != date('i')) {
				$newimg = true;
				$rand['time'] = date('i');
			}
			break;
		default: 
			//$newimg = true;
			break;
	}
	if ($newimg) {
		if (!strstr($image, "*") && intval($randimg))
			$Directory = ADS_COUNTER_DIR.'*.*';
		else
			$Directory = ADS_COUNTER_DIR.$image;
		$FILES = array_values(preg_grep('/\.(jpe?g|png|gif)$/i', glob($Directory)));
		$rand['image'] = basename($FILES[rand(0, sizeof($FILES)-1)]);
		update_option(ADS_OPTIONS_RANDOM , $rand );
	}
	return $rand['image'];
}

//=================================
//functions
//=================================
function adswsc_GetViewCounter($options) {
	global $wpdb;
	global $post;
	$table_name = $wpdb->prefix.ADS_PAGEFILE;

	$general = adswsc_GetOptions( ADS_OPTIONS_GENERAL );
	$ip = adswsc_getIP();
	$output= "";

	if (!empty($options['admin']) && !adswsc_isAdmin() ) 
		return $output;

	if (isset($options['count']) && absint($options['count']) > 0)
		$user_count = absint($options['count']);
	else if (!empty($options['page']) ) {
		$pid = get_queried_object_id();
		$pof = get_option( 'page_on_front' );
		$sof = get_option( 'show_on_front' );
		$pfp = get_option( 'page_for_posts' );
		$user_count = '';
		if ( $pid!=$pof && $pid!=$sof && $pid!=$pfp && $pid > 0)
			$user_count = $wpdb->get_var("SELECT sum(Count) FROM $table_name where PageID=".$pid);
	} else
		$user_count = $wpdb->get_var("SELECT Count FROM $table_name where IP='0'");
	if (!empty($options['add']) )
	  $user_count += intval($options['add']);
	
	$align = $options['align'] == '' ? '' :  'style="text-align:'.$options['align'].';"';
	switch ($options['block']) {
		case 'p': $output .=  '<p id="adswsc_block" '.$align.'>'; break;
		case 'div': $output .=  '<div id="adswsc_block" '.$align.'>'; break;
		default: $output .=  ($options['align'] == 'center') ? '<center>' : ''; 
				 $output .= '<span id="adswsc_block" >'; break;
	}
	$output .=  adswsc_TranslatePlaceHolder($options['before'], $options, $user_count);
	$output .= (! empty($options['block']) && ! empty($options['before'])) ? '<br>' : ' ';
	switch ($options['whunit']) {
		case '%': 
			$options['width'] = ($options['width'] > 100) ? 100 : $options['width']."%"; 
			$options['height'] = ($options['height'] > 100) ? 100 : $options['height']."%"; 
			break;
		case 'pt':		
			$options['width'] = ($options['width'] > 0) ? round(( $options['width'] * 96 / 72 ),0) : 0; 
			$options['height'] = ($options['height'] > 0) ? round(( $options['height'] * 96 / 72 ),0) : 0; 
			break;
		case 'em':	
			$options['width'] = ($options['width'] > 0) ? round(( $options['width'] * 16),0) : 0; 
			$options['height'] = ($options['height'] > 0) ? round(( $options['height'] * 16),0) : 0; 
			break;
		default:
			break;
	}
	$CountData = adswsc_MakeImage($user_count, $options);
	$bostyle = $options['bosize'] != '' ? 'border-width:'.$options['bosize'].'px; ' : '';
	$bostyle .= $options['botype'] != '' ? 'border-style:'.$options['botype'].'; ' : '';
	$bostyle .= $options['bocolor'] != '' ? 'border-color:'.$options['bocolor'].'; ' : '';
	$bostyle .= $options['boradius'] != '' ? 'border-radius:'.$options['boradius'].'px; ' : '';
	if ($options['text'] == "on") 
		$output .=  "<span id='adswsc_countertext'> ".$CountData." </span>";
	else {
		$w = $options['width'] ? " width='".$options['width']."'" : "";
		$h = $options['height'] ? " height='".$options['height']."'" : "";
		$output .= "<img id='adswsc_counter' style='".$bostyle."' src='".$CountData."' align='middle' ".$w." ".$h."/>";
	}
	$output .= (! empty($options['block']) && ! empty($options['after'])) ? '<br>' : ' ';
	$output .=  adswsc_TranslatePlaceHolder($options['after'], $options, $user_count);
	switch ($options['block']) {
		case 'p': $output .=  "</p>"; break;
		case 'div': $output .=  "</div>"; break;
		default: $output .=  ($options['align'] == 'center') ? '</span></center>' : '</span>'; break;
	}
	return $output;
}

//=================================
function adswsc_TranslatePlaceHolder($Text, $options, $user_count) {
	$Text = adswsc_getLanguage($Text);
	$posS = strpos($Text, '%[');
	$posE = strpos($Text, ']%');
	$len = ($posE  - $posS - 2);
	if ($posS !== false && $len > 0){
		$temp = substr($Text, $posS + 2, $len);
		$Text = str_ireplace('%['.$temp.']%', '%*%', $Text);
		if(is_user_logged_in()) {
			global $current_user;
			$current_user = wp_get_current_user(); 
			$temp = str_ireplace('%fname', $current_user->user_firstname, $temp);
			$temp = str_ireplace('%lname', $current_user->user_lastname, $temp);
			$temp = str_ireplace('%dname', $current_user->display_name, $temp);
			$temp = str_ireplace('%sname', $current_user->user_login, $temp);
			$temp = str_ireplace('%email', $current_user->user_email, $temp);
			$temp = str_ireplace('%id', $current_user->ID, $temp);
		}
		else
		 $temp = '';
		$Text = str_ireplace('%*%', $temp, $Text);
	}
	$Text = str_ireplace('%ip', adswsc_getIP(), $Text);
	$Text = str_ireplace('%image', preg_replace("/\.[^.]+$/", "", $options['image']), $Text);
	$Text = str_ireplace('%count', $user_count, $Text);
	return $Text;
}

//=================================
function adswsc_widget_title($title) {
	return adswsc_getLanguage($title);
}
add_filter('widget_title', 'adswsc_widget_title'); 

//=================================
function adswsc_getLanguage( $Text ) {
	$Text = str_ireplace('\n', '<br>', $Text);
	$ar = preg_split( "/({|})/", $Text );
	for($i = 1; $i < count($ar) && $i <= count($ar); $i+=2) {
		$a = substr(get_locale(),0, strlen($ar[$i]));
		if (adswsc_startsWith($ar[$i], $a ) ) 
			return $ar[$i+1];
	}		
	return $Text;
}

//=================================
function adswsc_startsWith($haystack, $needle) {
	return $needle === "" || strpos($haystack, $needle) === 0;
}

//=================================
function adswsc_MakeImage($Count, $args) {
	$imageFile = "nofile.jpg";
	if ( intval($args['randimg']) > 0)
		$imageFile = adswsc_GetRandomImage($args['randimg'], $args['image']);
	else {
		$Directory = ADS_COUNTER_DIR.basename($args['image']);
		$FILES = array_values(glob($Directory));
		if ($FILES && count($FILES) > 0)
			$imageFile = basename($FILES[rand(0, count($FILES)-1)]);
	}
	$m_cnt = strval($Count);
	if ($args['length'] != 0) {
		while (strlen($m_cnt) < $args['length']) {
			$m_cnt = ($args['fill'] == "on") ? "0".$m_cnt : " ".$m_cnt;
		}
	}
	if ($args['text'] == "on") 
		return trim($m_cnt);

	$len = strlen($m_cnt);
	$NUMS = array($len); 
	for($num = $len; $num >= 0; $num--) {
		$NUMS[$num] = (substr($m_cnt,$num,1) == " ") ? 10 : substr($m_cnt,$num,1);
	}
	// create image
	$image = ads_loadImage(ADS_COUNTER_DIR.$imageFile);
	if ($image == null) {
		$img = imagecreatetruecolor(80,20);
		$red = ImageColorAllocate ($img, 255, 100, 100);
		imagestring($img,3, 5, 2, "no counter", $red);
		if ($args['imgmaxw'] > 0) {
			$img = imagescale($img, $args['imgmaxw']);
		}
		ob_start();
		imagejpeg($img, null, 90);
		$image =  ob_get_contents();
		imagedestroy($img);
		ob_end_clean();
		return "data:image/jpeg;base64,".base64_encode($image);
	}
	$dx = $x = round((imageSX($image) / 11),0);
	$dy = $y = imageSY($image);
	if ($args['imgmaxw'] > 0) {
		$dx = round(($args['imgmaxw']/$len),0);
		$dy = $y / $x * $dx;
	}	
	$img = imagecreatetruecolor($len*$dx,$dy); //new output image
	if ( $args['backg'] == '' && file_exists(ADS_BACKGROUND_DIR.$imageFile) ) 
		$backg = $imageFile;
	else 
		$backg = $args['backg'];
	if ($backg != '') {
		$iback = ads_loadImage(ADS_BACKGROUND_DIR.$backg);
		$bx = round((imageSX($iback) / 11),0);
		imagecopyresampled($img,$iback,0,0,0,0, $len*$dx, $dy, $len*$bx, imageSY($iback));
		imagedestroy($iback);
	}
	for ($c = 0; $c < $len; $c++) {
		imagecopyresampled($img, $image, $c*$dx,0,$NUMS[$c]*$x, 0, $dx, $dy, $x, $y);
	} 
	imagedestroy($image);
	ob_start(); //header('Content-type: image/jpeg');
	imagejpeg($img, null, 90);
	$img =  ob_get_contents();
	ob_end_clean();
	return "data:image/jpeg;base64,".base64_encode($img);
}

//=================================
function ads_loadImage($imageFile) {
	$image = null;
	if (file_exists($imageFile)) {
		$ftype = pathinfo($imageFile, PATHINFO_EXTENSION);
		if (strcasecmp($ftype, "gif") == 0)
			$image = imagecreatefromgif($imageFile);
		else if (strcasecmp($ftype, "png") == 0)
			$image = imagecreatefrompng($imageFile);
		else
			$image = imagecreatefromjpeg($imageFile);
	}
	return $image;
}

//=================================
function adswsc_CheckHit() {
	global $wpdb;
	$general = adswsc_GetOptions( ADS_OPTIONS_GENERAL );

	//cleanup
	if ((current_time('timestamp') - absint($general['Cleanup'])) > 0) {
		adswsc_CleanUp($general['DeleteTime']);
		//save settings
		$general = adswsc_GetOptions( ADS_OPTIONS_GENERAL );
		$general['Cleanup'] = current_time('timestamp') + $general['CleanupTime'];
		update_option( ADS_OPTIONS_GENERAL, $general);
	}

	// check crawler
	if ( adswsc_IsCrawlerBot($general['Bots'])) 
		return;

	//ip hits, allways pageid=0
	$ip = adswsc_getIP();
	$table_name = $wpdb->prefix.ADS_PAGEFILE;
	$format = array ('%d','%s','%d', '%d', '%s');
	$DATA = array ('PageID' => 0 ,'IP' => $ip,'Time' => current_time('timestamp'), 'Count'=> 0, 'UsrAgent' => $_SERVER['HTTP_USER_AGENT'] );
	$result = $wpdb->get_results("SELECT PageID,IP,Time,Count FROM $table_name where PageID=0 and IP='$ip' LIMIT 1");
	if (!$result) { // insert new ipcounter
		$wpdb->insert( $table_name, $DATA, $format );
		$DATA['Time'] = 0;
	} else { // Get last hit
		$DATA['Time'] = $result[0]->Time;
		$DATA['Count'] = $result[0]->Count;
	}
	// Hit check
	if ((current_time('timestamp') - $DATA['Time']) > $general['CycleTime']) {
		//update ip counter, allways pageid=0
		$DATA['Time'] = current_time('timestamp');
		$DATA['Count']++;  
		$wpdb->update($table_name, $DATA, array('PageID' => 0, 'IP' => $ip), $format, array('%d','%s'));
		//update master counter, allways ip='0', pageid=0, time=0
		$count = $wpdb->get_var("SELECT Count FROM $table_name where PageID=0 and IP='0'");
		if ($count == 0) {
			$result = $wpdb->get_results("SELECT Count FROM $table_name where PageID=0 and IP='0'");
			if (!$result) { // new record! eliminate dublicate key warning (or add @ on insert)
				$DATA = array ('PageID' => 0 ,'IP' => '0','Time' => 0, 'Count'=> 0 );
				$wpdb->insert( $table_name, $DATA, $format );
			}
		}
		$wpdb->query("UPDATE ".$table_name." SET Count = ".++$count." WHERE PageID=0 and IP='0'");
	}
}

//=================================
function adswsc_CountPage($pageID) {
	global $wpdb;
	$general = adswsc_GetOptions( ADS_OPTIONS_GENERAL );

	if ( adswsc_IsCrawlerBot($general['Bots']) || $general['PageOn'] != 'on' || $pageID == 0)
		return;

	$ip = adswsc_getIP();
	$table_name = $wpdb->prefix.ADS_PAGEFILE;
	$format = array ('%d','%s','%d','%d','%s');
	$DATA = array ('PageID' => $pageID, 'IP' => $ip, 'Time' => current_time('timestamp'), 'Count'=> 1, 'UsrAgent' =>$_SERVER['HTTP_USER_AGENT']);
	$result = $wpdb->get_results("SELECT PageID,IP,Time,Count FROM $table_name where IP='".$ip."' AND PageID=".$pageID);
	if (!$result)
		$wpdb->insert( $table_name, $DATA, $format );
	else { // Get IP Data last hit
		$DATA['IP'] = $result[0]->IP;
		$DATA['Time'] = $result[0]->Time;
		$DATA['Count'] = $result[0]->Count;
	}
	//Update only after xx time again. 
	if ((current_time('timestamp') - $DATA['Time']) > $general['PageTime'])
	{
		$DATA['Time'] = current_time('timestamp');
		$DATA['Count']++;  
		$wpdb->update($table_name, $DATA, array('PageID' => $pageID, 'IP' => $ip), $format, array('%d','%s'));
	}
}

//=================================
function adswsc_getIP() {
	if (!empty($_SERVER['HTTP_CLIENT_IP']))
		return $_SERVER['HTTP_CLIENT_IP'];
	if (!empty($_SERVER['HTTP_X_FORWARDE‌​D_FOR']))
		return $_SERVER['HTTP_X_FORWARDED_FOR'];
	return $_SERVER['REMOTE_ADDR'];
}

//=================================
function adswsc_IsCrawlerBot($crawlers) {
	if (!isset($crawlers) || empty($crawlers))
		return false;
	$crawlers = str_replace(array(' ',','),array('','|'), $crawlers);
	$pattern = '/('.$crawlers.')/i';
	$agent = $_SERVER['HTTP_USER_AGENT'];
	$result = (isset($agent) && preg_match($pattern , $agent)); 
	return ($result == 1 ? true : false);
}

//=================================
function absintminmax($whatever, $min = 1, $max = 100) {
	if(intval($whatever) < $min) return $min;
	elseif(intval($whatever) > $max) return $max;
	return absint(intval($whatever));
}

//=================================
function adswsc_CleanUp($CleanupTime = 2592000) {
	global $wpdb;
	$table_name = $wpdb->prefix.ADS_PAGEFILE;
	$wpdb->query('DELETE FROM '.$table_name.' WHERE IP <> "0" and Time < '.(current_time('timestamp')-$CleanupTime));
}

//=================================
function adswsc_ResetCounter($Count){
	global $wpdb;
	$table_name = $wpdb->prefix.ADS_PAGEFILE;
	$format = array ('%d','%s','%d', '%d');
	$DATA = array ('PageID'=>0, 'IP' => '0','Time' => 0, 'Count'=> $Count );
	$result = $wpdb->get_results("SELECT PageID, IP,Time,Count FROM $table_name where IP = '0'");
	if (!$result)
		$wpdb->insert( $table_name, $DATA, $format );
	else
		$wpdb->update($table_name, $DATA, array('IP' => 0), $format, array('%s'));
}

//=================================
function adswsc_deletePost( $postid ){
	global $wpdb; // delete post/page id to, on adsPage table
	$table_name = $wpdb->prefix.ADS_PAGEFILE;
	$result = $wpdb->query("DELETE FROM $table_name where PageID=$postid");
}

//=================================
function adswsc_theContent( $content ) {
	global $post;
	if(is_feed()) 
		return $content;

	if(strpos($content,'more-link') !== false || strpos($content,'<!--more-->') !== false) 
		return $content;

	if (in_array( $post->post_type, array( 'post', 'page') ) ) 
		adswsc_CountPage($post->ID);

	return $content;
}

//=================================
//setup, install, deinstall
//=================================
function adswsc_DbInstall () {
	global $wpdb;
       
	$table_name = $wpdb->prefix . ADS_PAGEFILE;
	$Table = $wpdb->get_var("show tables like '$table_name'");
	if(strcasecmp($Table, $table_name) != 0) {	// No table, create
		$sql = "CREATE TABLE $table_name (
						PageID INT( 11 ) NOT NULL ,
						IP VARCHAR( 46 ) NOT NULL ,
						Time INT( 11 ) NOT NULL ,
						Count INT( 11 ) NOT NULL,
						UsrAgent VARCHAR ( 254 ) NULL,
						PRIMARY KEY ( PageID, IP ) );";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
	//2020-07-19
	$Column = $wpdb->get_results("SHOW COLUMNS FROM $table_name LIKE 'UsrAgent'");
	if (empty($Column)) {  //old table version, insert usragent
		$sql = "ALTER TABLE $table_name ADD UsrAgent VARCHAR( 254 ) NULL";
		$wpdb->query($sql);
	}
}

//=================================
function adswsc_Uninstall(){
  global $wpdb;
  $table_name = $wpdb->prefix . ADS_PAGEFILE;
  $wpdb->query("DROP TABLE IF EXISTS $table_name");

  delete_option( ADS_OPTIONS_GENERAL );
  delete_option( 'widget_adswscwidget' );
  delete_option( ADS_OPTIONS_SHORTCODE );
}

//=================================
function adswsc_AddStylesheet() {
	wp_register_style('adswscCSS', ADS_STYLE_URL.ADS_STYLE_NAMECSS);
	wp_enqueue_style( 'adswscCSS');
}

//=================================
function adswsc_Init() {
	$locale = apply_filters( 'plugin_locale', get_locale(), ADS_TEXT_DOMAIN );
	load_plugin_textdomain( ADS_TEXT_DOMAIN, FALSE, dirname( plugin_basename( __FILE__ ) ) . ADS_LANG_DIRNAME); 
}

//=================================
function adswsc_Loaded() {
	adswsc_DbInstall();
	adswsc_CheckHit();
}

//==================================
function adswsc_Scripts() { 
	wp_enqueue_script( 'adswsc_scripts', ADS_SCRIPT_URL.ADS_SCRIPT_NAMEJS, array('jquery'), '1.0', true ); 
	wp_localize_script( 'adswsc_scripts', 'adswcs_dopost', array( 'ajax_url' => admin_url( 'admin-ajax.php' )));
} 


//=================================================
function adswsc_GetFilesToArray($dir, $search) {
	$files = array();
	if (!is_dir($dir))
		return $files;
	$Directory = new RecursiveDirectoryIterator($dir, 
																							FilesystemIterator::SKIP_DOTS | 
																							FilesystemIterator::KEY_AS_PATHNAME);
	$Regex = new RegexIterator($Directory, $search, RecursiveRegexIterator::GET_MATCH);
	foreach ($Regex as $file) 
		array_push($files, basename($file[0]));
	return $files;
}

//==================================
function adswsc_widget_Callback() {
	$option = json_decode(str_replace(array('\"','\\\\'), array('"','\\'),
						(isset($_POST['option']) ? sanitize_text_field($_POST['option']) : '{}')),true);
	echo '<p>'.adswsc_GetViewCounter($option).'</p>';
	wp_die();
}

add_action('init', 'adswsc_Init');
add_action('plugins_loaded', 'adswsc_Loaded');
add_action('wp_print_styles', 'adswsc_AddStylesheet');
add_action('admin_print_styles', 'adswsc_AddStylesheet');
add_action('before_delete_post', 'adswsc_deletePost');
add_action('the_content', 'adswsc_theContent' );

if (is_admin()) {
	$general = adswsc_GetOptions(ADS_OPTIONS_GENERAL);
	if ($general['UseAjax'] == 'on') {
		add_action('admin_enqueue_scripts', 'adswsc_Scripts' ); 
		add_action('wp_ajax_adswsc_widget', 'adswsc_widget_Callback' ); 
	}
}

register_uninstall_hook( __FILE__, 'adswsc_Uninstall' );

?>