<?php
/*
 Shortcode for the WpSiteCount plugin
 Date : 2014/08/26
 Author: ad-software, André
*/
defined('ABSPATH') OR exit;

class adswsc_clsShortCode  {
 
	protected static $instance = NULL;

	public static function get_instance() {
		// create an object
		NULL === self::$instance and self::$instance = new self;
		return self::$instance; // return the object
  }

	//=================================
	public function post_handler($args) {
		//run function that actually does the work of the plugin
		if (isset($args['reset'])) 
			$options = adswsc_GetOptions( ADS_OPTIONS_SHORTCODE , true );
		else
			$options = adswsc_GetOptions( ADS_OPTIONS_SHORTCODE );
		$args = shortcode_atts( array (
			'title' => $options['title'],
			'before' => $options['before'],
			'after' => $options['after'],
			'width' => $options['width'],
			'height' => $options['height'],
			'whunit' => $options['whunit'],
			'image' => $options['image'],
			'backg' => (isset($options['backg']) ? $options['backg']:''),
			'align' => $options['align'],
			'length' => $options['length'],
			'fill' => $options['fill'],
			'text' => $options['text'],
			'page' =>  (isset($options['page']) ? $options['page']:''),
			'admin' => (isset($options['admin']) ? $options['admin']:''),
			'block' => $options['block'],
			'randimg' => $options['randimg'],
			'imgmaxw' => $options['imgmaxw'],
			'bosize' => $options['bosize'],
			'botype' => $options['botype'],
			'bocolor' => $options['bocolor'],
			'boradius' => $options['boradius'],
			'count' => 0,
			'add' => 0,
			'nocount' => '',
			'reset' => '',
			'save' => '',
		), $args);
		//send back text to replace shortcode in post
		return $this->post_function($args);
	}
	
	//=================================
	public function post_function($args) {
		// Filter chars and data
		if ($args['nocount'])
			return '&#91;'.ADS_PLUGIN_NAMESC.' &lt;args&gt; &#93;';
		$args['title'] = wp_specialchars_decode($args['title']);
		$args['before'] = wp_specialchars_decode($args['before']);
		$args['after'] = wp_specialchars_decode($args['after']);
		$args['width'] = absint($args['width']);
		$args['height'] = absint($args['height']); 
		$args['whunit'] = wp_specialchars_decode($args['whunit']); 
		$args['whunit'] = (in_array( $args['whunit'], array( '%', 'px', 'pt', 'em' ) ) ? $args['whunit'] : 'px' );
		$args['image'] = wp_specialchars_decode($args['image']);
		$args['backg'] = wp_specialchars_decode($args['backg']);
		$args['align'] = wp_specialchars_decode($args['align']);
		$args['align'] = (in_array( $args['align'], array( 'left', 'right', 'center', 'inherit', 'justify', '' ) ) ? $args['align'] : '' );
		$args['length'] = absint($args['length']);
		$args['fill'] = wp_specialchars_decode($args['fill']);
		$args['text'] = wp_specialchars_decode($args['text']);
		$args['block'] = wp_specialchars_decode($args['block']); 
		$args['block'] = (in_array( $args['block'], array( 'p', 'div', '' ) ) ? $args['block'] : '' );
		$args['randimg'] = absint($args['randimg']);
		$args['imgmaxw'] = absint($args['imgmaxw']);
		$args['bosize'] = min(9,max(0, absint($args['bosize']) ));
		$args['botype'] = wp_specialchars_decode($args['botype']); 
		$args['botype'] = (in_array( $args['botype'], 
			array( 'inset','outset','solid','dotted','double','hidden','ridge','initial','inherit','none' ) ) ? $args['botype'] : 'inset' );
		$args['bocolor'] = wp_specialchars_decode($args['bocolor']); 
		$args['boradius'] = min(12,max(0, absint($args['boradius']) )); 
		if ($args['save']) 
			update_option( ADS_OPTIONS_SHORTCODE , $args);
	
		//temp
		$args['add'] = absint($args['add']);
		$args['count'] = absint($args['count']);
		$args['page'] = wp_specialchars_decode($args['page']);
		$args['admin'] = wp_specialchars_decode($args['admin']);
		//send back text to calling function
		return adswsc_GetViewCounter($args);
	}
}	

//=================================
//SHORTCODE - register 
//=================================
add_shortcode( ADS_PLUGIN_NAMESC , array( adswsc_clsShortCode::get_instance(), 'post_handler') );

?>