<?php
/*
 display widget on dashboard to show a small statistic
 Date : 2015/10/23
 Date : 2016/02/09
 Author: ad-software, André
*/
defined('ABSPATH') OR exit;

if (!defined('ADS_DashUsag')) 		define('ADS_DashUsag', 'ads-DashUsagwidget');

// Class
class adswsc_clsDashUsagWidgets {
	//Constructor
    function __construct() {
        add_action( 'wp_dashboard_setup', array( $this, 'remove_dashboard_widgets' ) );
        add_action( 'wp_dashboard_setup', array( $this, 'add_dashboard_widgets' ) );
    }
	// Remove
	function remove_dashboard_widgets() {
		remove_meta_box( ADS_DashUsag, 'home', 'side' );
	}	
	// Add
    function add_dashboard_widgets() {
		wp_add_dashboard_widget( ADS_DashUsag,
			__('ADS-WpSiteCount - User Agent Statistic',ADS_TEXT_DOMAIN),
			array($this,'content_dashboard_widget' ));
	}	
	// display
	function content_dashboard_widget() {
		global $wpdb;
		$pageRows = 5;
		$period = 0;
		$searchDate = "";
		$table_name = $wpdb->prefix.ADS_PAGEFILE;
		$general = adswsc_GetOptions( ADS_OPTIONS_GENERAL );

		if (isset($_POST['usag_rows']))  
			$pageRows = (absint($_POST['usag_rows']));

		$results = $wpdb->get_results("SELECT COUNT(UsrAgent), UsrAgent FROM $table_name".
									  " WHERE UsrAgent IS NOT NULL AND PageID = 0 AND IP <> '0' ".
									  " GROUP BY UsrAgent ORDER BY UsrAgent;");

		$pageMax = sizeof($results);
		$pageMax = absint($pageMax / $pageRows) + ( ($pageMax % $pageRows) > 0 ? 1 : 0);
		$pageStart = 0;
		if (isset($_POST['usag_page']))  
			$pageStart = (absint($_POST['usag_page'])-1);
		if (isset($_POST['usag_next']))
			$pageStart += $pageStart < ($pageMax-1) ? 1 : 0;
		if (isset($_POST['usag_prev']))
			$pageStart -= $pageStart > 0 ? 1 : 0;
		if (isset($_POST['usag_top']))
			$pageStart = 0;
		if (isset($_POST['usag_last']))
			$pageStart = $pageMax-1;

		$results = $wpdb->get_results("SELECT COUNT(UsrAgent) as Rcount, UsrAgent FROM $table_name".
										" WHERE UsrAgent IS NOT NULL AND PageID = 0 AND IP <> '0' ".
									  " GROUP BY UsrAgent ORDER BY Rcount DESC ".
									  " LIMIT ".($pageStart * $pageRows).", ".$pageRows);
		echo "<p>".__('The table shows the count of user agents.', ADS_TEXT_DOMAIN).'</p>'; 
		echo '<form class="update" method="post" action="#" enctype="multipart/form-data">';
		echo '<input style="width:30px;" class="button" type="submit" name="usag_top" value="«">';
		echo '<input style="width:30px;" class="button" type="submit" name="usag_prev" value="‹">';
		echo '<select class="actions bulkactions" name="usag_page" onchange="this.form.submit()">';
		for ($x=1; $x <= $pageMax; $x++) {	
			echo '<option value="'.$x.'" '.($pageStart == ($x-1) ? "selected" : "" ).' >'.__('Page', ADS_TEXT_DOMAIN).' '.$x.'</option>';
		}
		echo '</select>&nbsp'.__('from', ADS_TEXT_DOMAIN).'&nbsp;'.$pageMax.'&nbsp;';
		echo '<input style="width:30px;" class="button" type="submit" name="usag_next" value="›">';
		echo '<input style="width:30px;" class="button" type="submit" name="usag_last" value="»">';
		echo ' '.__('rows', ADS_TEXT_DOMAIN);
		echo '&nbsp;<select class="actions bulkactions" name="usag_rows" onchange="this.form.submit()">';
		echo '<option value="5" '.($pageRows == 5 ? "selected" : "").'>5</option>';
		echo '<option value="10" '.($pageRows == 10 ? "selected" : "").'>10</option>';
		echo '<option value="20" '.($pageRows == 20 ? "selected" : "").'>20</option>';
		echo '<option value="50" '.($pageRows == 50 ? "selected" : "").'>50</option>';
		echo '</select> ';		
		echo '<p><table class="widefat"><thead><tr>';
		echo '<th width="1%" align="center" class="manage-column"><strong>'.__('Count', ADS_TEXT_DOMAIN).'</strong></th>';
		echo '<th class="manage-column"><strong>'.__('User Agent', ADS_TEXT_DOMAIN).'</strong></th>';
		echo '</tr></thead><tbody class="plugins">';
		if ($results) {
			$i=0;
			foreach($results as $result) { 
				$i++;
				if (($i % 2) == 1)
					echo '<tr style="background:#f5f5f5">';
				else
					echo '<tr>';
				echo '<td align="center">'.$result->Rcount.'</td>';
				echo '<td>'.(empty($result->UsrAgent)? __('unknown', ADS_TEXT_DOMAIN): $result->UsrAgent).'</td>';
				echo '</tr>';
			}	
		} else 
			echo '<tr><td>-</td><td><b>'.__('no data found', ADS_TEXT_DOMAIN).'</b></td></tr>';
		echo '</tbody></table></p>';
		echo '</form>';
		}
}

$adswsc_DashUsagWidget = new adswsc_clsDashUsagWidgets();
?>