<?php
/*
 Widget for the WpSiteCount plugin
 Date : 2017/01/25
 Author: ad-software, André
*/

defined('ABSPATH') OR exit;
add_action( 'widgets_init', 'adswsc_load_widget' );

// Register and load the widget
function adswsc_load_widget() {
	register_widget( 'adswsc_clsWidget' );
}

class adswsc_clsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(	
			'adswscWIDGET', // Base ID of your widget
			ADS_PLUGIN_NAME, // Widget name will appear in UI
			array( 'description' => __('Count the page hit from each ip and display a counter into widget or page.', ADS_TEXT_DOMAIN ), ) // Widget description
		);
	}

	// Creating widget front-end
	// This is where the action happens
	public function widget( $args, $instance ) {
		// new fields
		$options['title'] = !empty($instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : '';
		$options['before'] = !empty($instance['before'] ) ? $instance['before'] : '';
		$options['after'] =  !empty($instance['after'] ) ? $instance['after'] : '';
		$options['width'] = !empty($instance['width'] ) ? $instance['width'] : '';
		$options['height'] = !empty($instance['height'] ) ? $instance['height'] : '';
		$options['whunit'] = !empty($instance['whunit'] ) ? $instance['whunit'] : '';
		$options['image'] = !empty($instance['image'] ) ? $instance['image'] : '';
		$options['backg'] = !empty($instance['backg'] ) ? $instance['backg'] : '';
		$options['align'] = !empty($instance['align'] ) ? $instance['align'] : '';
		$options['length'] = !empty($instance['length'] ) ? $instance['length'] : '';
		$options['fill'] = !empty($instance['fill'] ) ? $instance['fill'] : '';
		$options['text'] = !empty($instance['text'] ) ? $instance['text'] : '';
		$options['page'] = !empty($instance['page'] ) ? $instance['page'] : '';
		$options['admin'] = !empty($instance['admin'] ) ? $instance['admin'] : '';
		$options['block'] = !empty($instance['block'] ) ? $instance['block'] : '';
		$options['randimg'] = !empty($instance['randimg'] ) ? $instance['randimg'] : '';
		$options['imgmaxw'] = !empty($instance['imgmaxw'] ) ? $instance['imgmaxw'] : '';
		$options['bosize'] = !empty($instance['bosize'] ) ? $instance['bosize'] : '';
		$options['botype'] = !empty($instance['botype'] ) ? $instance['botype'] : '';
		$options['bocolor'] = !empty($instance['bocolor'] )  ? $instance['bocolor'] : '';
		$options['boradius'] = !empty($instance['boradius'] ) ? $instance['boradius'] : '';
		echo $args['before_widget'];
		if ( !empty( $options['title'] ) )
			echo $args['before_title'] . $options['title'] . $args['after_title'];
		echo adswsc_GetViewCounter($options);
		echo $args['after_widget'];
	}

	// Updating widget replacing old instances with new
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( !empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['before'] = ( !empty( $new_instance['before'] ) ) ? strip_tags( $new_instance['before'] ) : '';
		$instance['after'] = ( !empty( $new_instance['after'] ) ) ? strip_tags( $new_instance['after'] ) : '';
		$instance['width'] = ( !empty( $new_instance['width'] ) ) ? strip_tags( $new_instance['width'] ) : '';
		$instance['height'] = ( !empty( $new_instance['height'] ) ) ? strip_tags( $new_instance['height'] ) : '';
		$instance['whunit'] = ( !empty( $new_instance['whunit'] ) ) ? strip_tags( $new_instance['whunit'] ) : '';
		$instance['image'] = ( !empty( $new_instance['image'] ) ) ? strip_tags( $new_instance['image'] ) : '';
		$instance['backg'] = ( !empty( $new_instance['backg'] ) ) ? strip_tags( $new_instance['backg'] ) : '';
		$instance['align'] = ( !empty( $new_instance['align'] ) ) ? strip_tags( $new_instance['align'] ) : '';
		$instance['length'] = ( !empty( $new_instance['length'] ) ) ? strip_tags( $new_instance['length'] ) : '';
		$instance['fill'] = ( !empty( $new_instance['fill'] ) ) ? strip_tags( $new_instance['fill'] ) : '';
		$instance['text'] = ( !empty( $new_instance['text'] ) ) ? strip_tags( $new_instance['text'] ) : '';
		$instance['page'] = ( !empty( $new_instance['page'] ) ) ? strip_tags( $new_instance['page'] ) : '';
		$instance['admin'] = ( !empty( $new_instance['admin'] ) ) ? strip_tags( $new_instance['admin'] ) : '';
		$instance['block'] = ( !empty( $new_instance['block'] ) ) ? strip_tags( $new_instance['block'] ) : '';
		$instance['randimg'] = ( !empty( $new_instance['randimg'] ) ) ? strip_tags( $new_instance['randimg'] ) : '';
		$instance['imgmaxw'] = ( !empty( $new_instance['imgmaxw'] ) ) ? strip_tags( $new_instance['imgmaxw'] ) : '';
		$instance['bosize'] = ( !empty( $new_instance['bosize'] ) ) ? strip_tags(min(9,max(0, absint( $new_instance['bosize'] ) ))) : '';
		$instance['botype'] = ( !empty( $new_instance['botype'] ) ) ? strip_tags( $new_instance['botype'] ) : '';
		$instance['bocolor'] = ( !empty( $new_instance['bocolor'] ) ) ? strip_tags( $new_instance['bocolor'] ) : '';
		$instance['boradius'] = ( !empty( $new_instance['boradius'] ) ) ? strip_tags(  min(12,max(0, absint( $new_instance['boradius'] ) ))) : '';
		return $instance;
	}
		
	// Widget Backend 
	public function form( $instance ) {
		$FILES = adswsc_GetFilesToArray(ADS_COUNTER_DIR, '/.*\.(jpe?g|png|gif)$/i');
		$BGROUND = adswsc_GetFilesToArray(ADS_BACKGROUND_DIR,'/.*\.(jpe?g|png|gif)$/i');
		$default_file = $FILES[0];
		$title = isset( $instance[ 'title' ] ) ? $instance[ 'title' ] : __('Visitor counter', ADS_TEXT_DOMAIN);
		$before = isset( $instance[ 'before' ] ) ? $instance[ 'before' ] : __('Visits since 2014', ADS_TEXT_DOMAIN);
		$after = isset( $instance[ 'after' ] ) ? $instance[ 'after' ] : '%['.
						__('Welcome %dname', ADS_TEXT_DOMAIN).'\n]%'.	__('Your IP: %ip', ADS_TEXT_DOMAIN);
		$width = isset( $instance[ 'width' ] ) ? $instance[ 'width' ] : 180;
		$height = isset( $instance[ 'height' ] ) ? $instance[ 'height' ] : '';
		$whunit = isset( $instance[ 'whunit' ] ) ? $instance[ 'whunit' ] : 'px';
		$image = isset( $instance[ 'image' ] ) ? $instance[ 'image' ] : $default_file;
		$backg = isset( $instance[ 'backg' ] ) ? $instance[ 'backg' ] : '';
		$align = isset( $instance[ 'align' ] ) ? $instance[ 'align' ] : 'center';
		$length = isset( $instance[ 'length' ] ) ? $instance[ 'length' ] : 7;
		$fill = isset( $instance[ 'fill' ] ) ? $instance[ 'fill' ] : '';
		$text = isset( $instance[ 'text' ] ) ? $instance[ 'text' ] : '';
		$page = isset( $instance[ 'page' ] ) ? $instance[ 'page' ] : '';
		$admin = isset( $instance[ 'admin' ] ) ? $instance[ 'admin' ] : '';
		$block = isset( $instance[ 'block' ] ) ? $instance[ 'block' ] : 'p';
		$imgmaxw = isset( $instance[ 'imgmaxw' ] ) ? $instance[ 'imgmaxw' ] : 250;
		$randimg = isset( $instance[ 'randimg' ] ) ? $instance[ 'randimg' ] : 0;
    $bosize = isset( $instance[ 'bosize' ] ) ? $instance[ 'bosize' ] : 3;
		$botype = isset( $instance[ 'botype' ] ) ? $instance[ 'botype' ] : 'inset';
		$bocolor = isset( $instance[ 'bocolor' ] ) ? $instance[ 'bocolor' ] : 'white';
		$boradius = isset( $instance[ 'boradius' ] ) ? $instance[ 'boradius' ] : 3;
		
		$options = array (
			'title' => $title,
			'before' => $before,
			'after' => $after,
			'width' => $width,
			'height' => $height,
			'whunit' => $whunit,
			'image' => $image,
			'backg' => $backg,
			'align' => $align,
			'length' => $length,
			'fill' => $fill,
			'text' => $text,
			'page' => $page,
			'admin' => $admin,
			'block' => $block,
			'imgmaxw' => $imgmaxw,
			'randimg' => $randimg,
			'bosize' => $bosize,
			'botype' => $botype,
			'bocolor' => $bocolor,
			'boradius' => $boradius,
		);
			
		// Widget admin form
		// title
		echo '<div class="adswsc_widget">';
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'title' ).'">'.__('Title text', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<input class="'.$this->get_field_id('class').'" type="text" maxlength="200" class="widefat" id="'.$this->get_field_id( 'title' ).'" name="'.$this->get_field_name( 'title' ).'" value="'.esc_attr( $title ).'" />';
		echo '</div>';
		
		// before
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'before' ).'">'.__('Text before counter', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<input class="'.$this->get_field_id('class').'" type="text" maxlength="200" class="widefat" id="'.$this->get_field_id( 'before' ).'" name="'.$this->get_field_name( 'before' ).'" value="'.esc_attr( $before ).'" />';
		echo '</div>';

		// after
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'after' ).'">'.__('Text after counter', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<input class="'.$this->get_field_id('class').'" type="text" maxlength="200" class="widefat" id="'.$this->get_field_id( 'after' ).'" name="'.$this->get_field_name( 'after' ).'" value="'.esc_attr( $after ).'" />';
		echo '</div>';

		
		// width/height
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'width' ).'">'.__('Dynamic size width/hight/unit', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<span style="vertical-align:top; white-space:nowrap;">';
		echo '<input class="'.$this->get_field_id('class').'" style="width:20%;" type="text" maxlength="4" class="widefat" id="'.$this->get_field_id( 'width' ).'" name="'.$this->get_field_name( 'width' ).'" value="'.esc_attr( $width ).'"/>';
		echo ' <input class="'.$this->get_field_id('class').'" style="width:20%;" type="text" maxlength="3" class="widefat" id="'.$this->get_field_id( 'height' ).'" name="'.$this->get_field_name( 'height' ).'" value="'.esc_attr( $height ).'" />';
		echo '<select class="'.$this->get_field_id('class').'" style="width:auto;vertical-align:top;" id="'.$this->get_field_id( 'whunit' ).'" name="'.$this->get_field_name( 'whunit' ).'" >';
		echo '<option value="%" '.($whunit == '%' ? "selected" : "" ).' >%</option>';
		echo '<option value="px" '.($whunit == 'px' ? "selected" : "" ).' >Pixels</option>';
		echo '<option value="pt" '.($whunit == 'pt' ? "selected" : "" ).' >Points</option>';
		echo '<option value="em" '.($whunit == 'em' ? "selected" : "" ).' >Ems</option>';
		echo '</select>';
		echo '</span>';
		echo '</div>';

		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'width' ).'">'.__('Out max width (0=fullsize)', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<input class="'.$this->get_field_id('class').'" style="width:20%;" type="text"  maxlength="4" class="widefat" id="'.$this->get_field_id( 'imgmaxw' ).'" name="'.$this->get_field_name( 'imgmaxw' ).'" value="'.esc_attr( $imgmaxw ).'"/> px';
		echo '</div>';
		
		// border
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'bosize' ).'">'.__('border size/radius/#color/type', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<input class="'.$this->get_field_id('class').'" style="width:4em;" type="number" maxlength="1" min="0" max="9" class="widefat" id="'.$this->get_field_id( 'bosize' ).'" name="'.$this->get_field_name( 'bosize' ).'" value="'.min(9,max(0, absint( $bosize ))).'"/>';
		echo ' <input class="'.$this->get_field_id('class').'" style="width:4em;" type="number" maxlength="1" min="0" max="12" class="widefat" id="'.$this->get_field_id( 'boradius' ).'" name="'.$this->get_field_name( 'boradius' ).'" value="'.min(12,max(0, absint( $boradius ))).'"/>';
		echo ' <input class="'.$this->get_field_id('class').'" style="width:6em;" type="text"  class="widefat" id="'.$this->get_field_id( 'bocolor' ).'" name="'.$this->get_field_name( 'bocolor' ).'" value="'.esc_attr( $bocolor ).'" />';
		echo '<select class="'.$this->get_field_id('class').'" style="vertical-align:top;" id="'.$this->get_field_id( 'botype' ).'" name="'.$this->get_field_name( 'botype' ).'" >';
		echo '<option value="inset" '.($botype == 'inset' ? "selected" : "" ).' >inset</option>';
		echo '<option value="outset" '.($botype == 'outset' ? "selected" : "" ).' >outset</option>';
		echo '<option value="solid" '.($botype == 'solid' ? "selected" : "" ).' >solid</option>';
		echo '<option value="dotted" '.($botype == 'dotted' ? "selected" : "" ).' >dotted</option>';
		echo '<option value="double" '.($botype == 'double' ? "selected" : "" ).' >double</option>';
		echo '<option value="hidden" '.($botype == 'hidden' ? "selected" : "" ).' >hidden</option>';
		echo '<option value="ridge" '.($botype == 'ridge' ? "selected" : "" ).' >ridge</option>';
		echo '<option value="initial" '.($botype == 'initial' ? "selected" : "" ).' >initial</option>';
		echo '<option value="inherit" '.($botype == 'inherit' ? "selected" : "" ).' >inherit</option>';
		echo '<option value="none" '.($botype == 'none' ? "selected" : "" ).' >none</option>';
		echo '</select>';
		echo '</div>';
	
		// image
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'image' ).'">'.__('Image', ADS_TEXT_DOMAIN).'</label>';
		echo '<select class="'.$this->get_field_id('class').'" id="'.$this->get_field_id( 'image' ).'" name="'.$this->get_field_name( 'image' ).'" style="width:100%">';
		if (sizeof($FILES) == 0) {
			$tmp = __('Sorry, no counter image found', ADS_TEXT_DOMAIN);
			echo '<option value="'.$tmp.'" selected >'.$tmp.'</option>';
		} else {
			for($x = 0; $x < sizeof($FILES); $x++) { 
				echo '<option value="'.$FILES[$x].'" '.($image == $FILES[$x] ? "selected" : "" ).' >'.$FILES[$x].'</option>';
			}
		}  
		echo '</select>';
		echo '</div>';

		// background
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'backg' ).'">'.__('Background', ADS_TEXT_DOMAIN).'</label>';
		echo '<select class="'.$this->get_field_id('class').'" id="'.$this->get_field_id( 'backg' ).'" name="'.$this->get_field_name( 'backg' ).'" style="width:100%">';
		if (sizeof($BGROUND) == 0) {
			$tmp = __('Sorry, no background image found', ADS_TEXT_DOMAIN);
			echo '<option value="" selected >'.$tmp.'</option>';
		} else {
			echo '<option value="" selected >'.__('auto', ADS_TEXT_DOMAIN).'</option>';
			for($x = 0; $x < sizeof($BGROUND); $x++) { 
				echo '<option value="'.basename($BGROUND[$x]).'" '.($backg == basename($BGROUND[$x]) ? "selected" : "" ).' >'.basename($BGROUND[$x]).'</option>';
			}
		}  
		echo '</select>';
		echo '</div>';

		//Align and Length and Block
		echo '<div>';
		echo '<label class="selectit" for="'.$this->get_field_id( 'align' ).'">'.__('align, length and block type', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<select class="'.$this->get_field_id('class').'" style="" id="'.$this->get_field_id( 'align' ).'" name="'.$this->get_field_name( 'align' ).'" >';
		echo '<option value="left" '.($align == 'left' ? "selected" : "" ).' >'.__('left', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="right" '.($align == 'right' ? "selected" : "" ).' >'.__('right', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="center" '.($align == 'center' ? "selected" : "" ).' >'.__('center', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="inherit" '.($align == 'inherit' ? "selected" : "" ).' >'.__('inherit', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="justify" '.($align == 'justify' ? "selected" : "" ).' >'.__('justify', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="" '.($align == '' ? "selected" : "" ).' >'.__('none', ADS_TEXT_DOMAIN).'</option>';
		echo '</select> ';
		echo '<select class="'.$this->get_field_id('class').'" id="'.$this->get_field_id( 'length' ).'" name="'.$this->get_field_name( 'length' ).'" >';
		for($x = 0; $x <= 9; $x++) {	
			echo '<option value="'.$x.'" '.($length == $x ? "selected" : "" ).' >'.$x.'</option>';
		} 
		echo '</select> ';
		echo '<select class="'.$this->get_field_id('class').'" id="'.$this->get_field_id( 'block' ).'" name="'.$this->get_field_name( 'block' ).'" >';
		echo '<option value="p" '.($block == 'p' ? "selected" : "" ).' >p</option>';
		echo '<option value="div" '.($block == 'div' ? "selected" : "" ).' >div</option>';
		echo '<option value="" '.($block == '' ? "selected" : "" ).' >'.__('none', ADS_TEXT_DOMAIN).'</option>';
		echo '</select>';
		echo '</div>';
		
		//other options, fill, text, page, admin
		echo '<div style="vertical-align:middle;">';
		echo '<label for="'.$this->get_field_id( 'option' ).'">'.__('other options', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<span style="white-space:nowrap;"><input class="'.$this->get_field_id('class').'" value="on" type="checkbox" id="'.$this->get_field_id( 'fill' ).'" name="'.
					$this->get_field_name( 'fill' ).'" '.($fill == "on" ? "checked" : "" ).' />'.
					__('fill with zerro', ADS_TEXT_DOMAIN).'</span>';
		echo ' <span style="white-space:nowrap;" ><input class="'.$this->get_field_id('class').'" value="on" type="checkbox" id="'.$this->get_field_id( 'text' ).'" name="'.
					$this->get_field_name( 'text' ).'" '.($text == "on" ? "checked" : "" ).' />'.
					__('display as text', ADS_TEXT_DOMAIN).'</span>';
		echo ' <span style="white-space:nowrap;"><input class="'.$this->get_field_id('class').'" value="on" type="checkbox" id="'.$this->get_field_id( 'page' ).'" name="'.
					$this->get_field_name( 'page' ).'" '.($page == "on" ? "checked" : "" ).' />'.
					__('Page-Counter', ADS_TEXT_DOMAIN).'</span>';
		echo ' <span style="white-space:nowrap;"><input class="'.$this->get_field_id('class').'" value="on" type="checkbox" id="'.$this->get_field_id( 'admin' ).'" name="'.
					$this->get_field_name( 'admin' ).'" '.($admin == "on" ? "checked" : "" ).' />'.
					__('only Admin', ADS_TEXT_DOMAIN).'</span>';
		echo '</div>';
		
		//random counter
		echo '<div>';
		echo '<label for="'.$this->get_field_id( 'randimg' ).'">'.__('random type', ADS_TEXT_DOMAIN).'</label><br>';
		echo '<select class="'.$this->get_field_id('class').'" id="'.$this->get_field_id( 'randimg' ).'" name="'.$this->get_field_name( 'randimg' ).'" >';
		echo '<option value="0" '.($randimg == 0 ? "selected" : "" ).' >'.__('none', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="5" '.($randimg == 5 ? "selected" : "" ).' >'.__('every minute', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="1" '.($randimg == 1 ? "selected" : "" ).' >'.__('hourly', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="2" '.($randimg == 2 ? "selected" : "" ).' >'.__('dayli', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="3" '.($randimg == 3 ? "selected" : "" ).' >'.__('weekly', ADS_TEXT_DOMAIN).'</option>';
		echo '<option value="4" '.($randimg == 4 ? "selected" : "" ).' >'.__('monthly', ADS_TEXT_DOMAIN).'</option>';
		echo '</select>';
		echo '</div>';
		//show counter
		$options['page'] = '';
		echo '<span id="'.$this->get_field_id( 'cnt' ).'" ><p>'.adswsc_GetViewCounter($options).'</p></span>';
		echo '</div>';
		$general = adswsc_GetOptions( ADS_OPTIONS_GENERAL );
		if ($general['UseAjax'] == 'on') {
?>
<script type="text/javascript">
	jQuery(<?php echo "\".".$this->get_field_id('class')."\""; ?>).on("change", function() {
		jQuery(this).showCounter(<?php echo "\".".$this->get_field_id('class')."\""; ?>, <?php echo "\"#".$this->get_field_id('cnt')."\""; ?>);
	});

</script>
<?php 
		}
	}
}
?>